--[[
  * Wykkyd's [ Quest Tools ]
  * Sponsored & Supported by: Mostly Harmless (mostly-harmless-guild.com)
  * Author: Wykkyd, aka Wykkyd Gaming (wykkyd.gaming@gmail.com)
  * Special Thanks To: Zenimax Online Studios & Bethesda for The Elder Scrolls Online
]]--

local LAM = LibStub("LibAddonMenu-1.0")

WF_QuestTools = {}
WF_QuestTools.__index = WF_QuestTools
WF_QuestTools.AddonID = "mhQuestTools"

JOV_Set = {}

WF_QuestTools.Ready, WF_QuestTools.AddonName, WF_QuestTools.AddonAbbrev, WF_QuestTools.AddonVersion, WF_QuestTools.AddonDescr = WF_RegisterFactory(
	WF_QuestTools.AddonID,
	{
		AddonID = WF_QuestTools.AddonID,
		AddonName = "[WF] Quest Tools",
		AddonAbbrev = "qt",
		Author = "Wykkyd",
		AddonVersion = "14.07.03.1",
		ExpectedFrameworkVersion = "1.4.21.1",
		StartUp = function()
			WF_SlashCommand("qt", WF_QuestTools.CommandLine)
			WF_SlashCommand("qta", WF_QuestTools.Abandon)
			WF_SlashCommand("qtbl", WF_QuestTools.BlackList)
			WF_SlashCommand("qts", WF_QuestTools.Share)
			WF_SlashCommand("qtwl", WF_QuestTools.WhiteList)
			WF_SlashCommand("qtt", WF_QuestTools.Track)

			WF_Event( EVENT_QUEST_ADDED, WF_QuestTools.QuestAdded, WF_QuestTools.AddonID, false )
			if WF_QuestTools.UISettings["Enabled"] then
				WF_QuestTools.UI.QuestTracker()
				WF_QuestTools.ZoneFontChange()
			end

			WF_SettingsMenu.AddHeader("Quest Tools")
			WF_SettingsMenu.AddCheckbox("Show alerts in chat", nil, function()
				return WF_GetOrDefault( false, WF_QuestTools.UISettings["verbose"])
			end, function(val)
				WF_QuestTools.UISettings["verbose"] = val
			end)
			WF_SettingsMenu.AddCheckbox("Enable Quest Tracker |c656565 (move via top edge)|r", nil, function()
				return WF_QuestTools.UISettings.Enabled
			end, function(val)
				WF_QuestTools.UISettings.Enabled = val
				WF_QuestTools.UI.QuestEventCallback()
				WF_QuestTools.ZoneFontChange()
			end)
			WF_SettingsMenu.AddCheckbox("- Lock In Place", nil, function()
				return WF_GetOrDefault( false, WF_QuestTools.UISettings["lockinplace"] )
			end, function(val)
				WF_QuestTools.UISettings["lockinplace"] = val
				if val then
					WF_QuestTools_Tracker:Lock()
				else
					WF_QuestTools_Tracker:Move()
				end
			end)
			WF_SettingsMenu.AddCheckbox("- Show All Quest Details", nil, function()
				return WF_QuestTools.UISettings.ShowAllDetails
			end, function(val)
				WF_QuestTools.UISettings.ShowAllDetails = val
				WF_QuestTools.UI.QuestEventCallback()
			end)
			WF_SettingsMenu.AddCheckbox("- Single Quest Only (coming soon)", nil, function()
				return WF_QuestTools.UISettings.SingleQuest
			end, function(val)
				WF_QuestTools.UISettings.SingleQuest = val
				WF_QuestTools.UI.QuestEventCallback()
			end)
			WF_SettingsMenu.AddCheckbox("Always Share (/qt always share)", nil, function()
				return WF_QuestTools.UISettings.SetToAlwaysShare
			end, function(val)
				WF_QuestTools.UISettings.SetToAlwaysShare = val
			end)
			WF_SettingsMenu.AddCheckbox("Always Track (/qt always track)", nil, function()
				return WF_QuestTools.UISettings.SetToAlwaysTrack
			end, function(val)
				WF_QuestTools.UISettings.SetToAlwaysTrack = val
			end)
			WF_SettingsMenu.AddColorPicker("Tracker Drag Bar", "Color of the bar at the top for moving the window",
				function()
					local c = WF_QuestTools.UISettings.barColor
					return c.r, c.g, c.b, c.a
				end,
				function(r,g,b,a)
					WF_QuestTools.UISettings.barColor = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}
					if WF_QuestTools_Tracker ~= nil then
						WF_QuestTools_Tracker.Title.Backdrop:SetCenterColor( r, g, b, a )
						WF_QuestTools_Tracker.MouseOut()
					end
				end
			)
			WF_SettingsMenu.AddColorPicker("Background", "Opacity and color of the background frame",
				function()
					local c = WF_QuestTools.UISettings.Background
					return c.r, c.g, c.b, c.a
				end,
				function(r,g,b,a)
					WF_QuestTools.UISettings.Background = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}
					if WF_QuestTools_Tracker ~= nil then
						WF_QuestTools_Tracker.UnderlayBackdrop:SetCenterColor( r, g, b, a )
						WF_QuestTools_Tracker.MouseOut()
					end
				end
			)
			WF_SettingsMenu.AddSlider("Mouse-Out Opacity", "Transparency of the whole frame", 0, 100, 1,
				function()
					return WF_QuestTools.UISettings.MouseOutAlpha * 100
				end,
				function(val)
					WF_QuestTools.UISettings.MouseOutAlpha = val / 100
					if WF_QuestTools_Tracker then
						WF_QuestTools_Tracker.OutAlpha = val / 100
						WF_QuestTools_Tracker.MouseOut()
					end
					WF_QuestTools.ZoneFontChange()
				end
			)
			WF_SettingsMenu.AddSlider("Mouse-In Opacity", "Transparency of the whole frame", 0, 100, 1,
				function()
					return WF_QuestTools.UISettings.MouseInAlpha * 100
				end,
				function(val)
					WF_QuestTools.UISettings.MouseInAlpha = val / 100
					if WF_QuestTools_Tracker then
						WF_QuestTools_Tracker.InAlpha = val / 100
					end
					WF_QuestTools.ZoneFontChange()
				end
			)

			WF_SettingsMenu.AddCheckbox("Joviex's Tweaks", nil,
				function()
					return WF_QuestTools.UISettings.Joviex
				end,
				function(val)
					WF_QuestTools.UISettings.Joviex = val
					for _, control in ipairs(JOV_Set) do
						control:SetHidden(not val)
					end

					--[[local val = false
					if WF_QuestTools.Filter.Override ~= nil then
						val = WF_QuestTools.Filter.Override
					end
					local h = 0
					if val then h = 20 end
					for _, control in ipairs(JoviLevel) do
						control:SetHeight(h)
					end]]
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddHeader("Joviex's Quest Tracker Tweaks")
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddCheckbox("Show Tracker in Settings", "Allow the tracker window to be visible when the settings panel is up",
				function()
					return WF_QuestTools.Joviex.ShowInSettings
				end,
				function(val)
					WF_QuestTools.Joviex.ShowInSettings = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddSlider("Tracker Width", "Width of the Quest Tracker Frame", 200, 500, 10,
				function()
					return WF_QuestTools.Joviex.width
				end,
				function(val)
					WF_QuestTools.Joviex.width = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] =  WF_SettingsMenu.AddCheckbox("Sort Quests by LVL", nil,
				function()
					return WF_QuestTools.Filter.Sort
				end, function(val)
					WF_QuestTools.Filter.Sort = val
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddCheckbox("Quest Distance", nil,
				function()
					return WF_QuestTools.Filter.Distance
				end,
				function(val)
					WF_QuestTools.Filter.Distance = val
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddCheckbox("Override Quest Level Color", nil,
				function()
					return WF_QuestTools.Filter.Override
				end,
				function(val)
					WF_QuestTools.Filter.Override = val
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddSlider("Quest Level Low Split", "Split point below the current Character vs. Quest level to switch from Easy to Very Easy", 1, 10, 1,
				function()
					return WF_QuestTools.Filter.ConNeg
				end,
				function(val)
					WF_QuestTools.Filter.ConNeg = val
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddSlider("Quest Level High Split", "Split point above current Character vs. Quest level to switch from Difficult to Hard", 1, 10, 1,
				function()
					return WF_QuestTools.Filter.ConPos
				end,
				function(val)
					WF_QuestTools.Filter.ConPos = val
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddColorPicker(" - Very Easy", "Color of Quests -4 your current level",
				function()
					local c = WF_QuestTools.Filter.Worthless
					return c.r, c.g, c.b, 1
				end,
				function(r,g,b,a)
					WF_QuestTools.Filter.Worthless = {["r"] = r, ["g"] = g, ["b"] = b}
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddColorPicker(" - Easy", "Color of Quests -2 your current level",
				function()
					local c = WF_QuestTools.Filter.Easy
					return c.r, c.g, c.b, 1
				end,
				function(r,g,b,a)
					WF_QuestTools.Filter.Easy = {["r"] = r, ["g"] = g, ["b"] = b}
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddColorPicker(" - Normal", "Color of Quests at your current level",
				function()
					local c = WF_QuestTools.Filter.Par
					return c.r, c.g, c.b, 1
				end,
				function(r,g,b,a)
					WF_QuestTools.Filter.Par = {["r"] = r, ["g"] = g, ["b"] = b}
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddColorPicker(" - Difficult", "Color of Quests +2 your current level",
				function()
					local c = WF_QuestTools.Filter.Difficult
					return c.r, c.g, c.b, 1
				end,
				function(r,g,b,a)
					WF_QuestTools.Filter.Difficult = {["r"] = r, ["g"] = g, ["b"] = b}
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddColorPicker(" - Very Hard", "Color of Quests +4 your current level",
				function()
					local c = WF_QuestTools.Filter.Hard
					return c.r, c.g, c.b, 1
				end,
				function(r,g,b,a)
					WF_QuestTools.Filter.Hard = {["r"] = r, ["g"] = g, ["b"] = b}
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddDropdown("Zone Title Font", "The zone font", WF_QuestTools._fonts,
				function()
					return WF_QuestTools.Zone.Font
				end,
				function(val)
					WF_QuestTools.Zone.Font = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddDropdown("Zone Font Style", "The zone font style", WF_QuestTools._fontStyles,
				function()
					return WF_QuestTools.Zone.Style
				end,
				function(val)
					WF_QuestTools.Zone.Style = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddSlider("Zone Font Size", "The zone font size", 8, 24, 1,
				function()
					return WF_QuestTools.Zone.Size
				end,
				function(val)
					WF_QuestTools.Zone.Size = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddColorPicker("Zone Font Color", "The zone title color",
				function()
					local c = WF_QuestTools.Zone.Color
					return c.r, c.g, c.b, 1
				end,
				function(r,g,b,a)
					WF_QuestTools.Zone.Color = {["r"] = r, ["g"] = g, ["b"] = b}
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddSlider("Zone Quest Counter Font Size", "The number of quests per zone font size", 14, 22, 1,
				function()
					return WF_QuestTools.Zone.CounterSize
				end,
				function(val)
					if val > WF_QuestTools.Zone.Size then
						val = WF_QuestTools.Zone.Size
					end
					WF_QuestTools.Zone.CounterSize = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddColorPicker("Zone Quest Counter Color", "The color of the counter for the quest's in this zone",
				function()
					local c = WF_QuestTools.Zone.Counter
					return c.r, c.g, c.b, 1
				end,
				function(r,g,b,a)
					WF_QuestTools.Zone.Counter = {["r"] = r, ["g"] = g, ["b"] = b}
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddDropdown("Quest Title Font", "The quest title font", WF_QuestTools._fonts,
				function()
					return WF_QuestTools.Title.Font
				end,
				function(val)
					WF_QuestTools.Title.Font = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddDropdown("Quest Title Font Style", "The quest title font style", WF_QuestTools._fontStyles,
				function()
					return WF_QuestTools.Title.Style
				end,
				function(val)
					WF_QuestTools.Title.Style = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddSlider("Quest Title Font Size", "The quest title font size", 8, 24, 1,
				function()
					return WF_QuestTools.Title.Size
				end,
				function(val)
					WF_QuestTools.Title.Size = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddDropdown("Objective Font", "The quest objective font", WF_QuestTools._fonts,
				function()
					return WF_QuestTools.Body.Font
				end,
				function(val)
					WF_QuestTools.Body.Font = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddDropdown("Objective Font Style", "The quest objective font style", WF_QuestTools._fontStyles,
				function()
					return WF_QuestTools.Body.Style
				end,
				function(val)
					WF_QuestTools.Body.Style = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			JOV_Set[#JOV_Set+1] = WF_SettingsMenu.AddSlider("Objective Font Size", "The quest objective font size", 8, 24,1,
				function()
					return WF_QuestTools.Body.Size
				end,
				function(val)
					WF_QuestTools.Body.Size = val
					WF_QuestTools.UI.QuestEventCallback()
					WF_QuestTools.ZoneFontChange()
				end
			)
			for _, control in ipairs(JOV_Set) do
				control:SetHidden(not WF_QuestTools.UISettings.Joviex)
			end
		end,
		SavedVariables = function()
			WF_QuestTools.Filter = ZO_SavedVars:New(WF_QuestTools.AddonID, 2, "filter", WF_QuestTools.Filter, "QT")
			WF_QuestTools.Zone = ZO_SavedVars:New(WF_QuestTools.AddonID, 2, "zone", WF_QuestTools.Zone, "QT")
			WF_QuestTools.Title = ZO_SavedVars:New(WF_QuestTools.AddonID, 2, "title", WF_QuestTools.Title, "QT")
			WF_QuestTools.Body = ZO_SavedVars:New(WF_QuestTools.AddonID, 2, "body", WF_QuestTools.Body, "QT")
			WF_QuestTools.Joviex = ZO_SavedVars:New(WF_QuestTools.AddonID, 2, "bg", WF_QuestTools.Joviex, "QT")

			WF_QuestTools.QuestsToAbandon = ZO_SavedVars:New(WF_QuestTools.AddonID, 2, "BlackList", {}, "QT") or {}
			WF_QuestTools.QuestsToShare = ZO_SavedVars:New(WF_QuestTools.AddonID, 2, "WhiteList", {}, "QT") or {}

			WF_QuestTools.UISettings = ZO_SavedVars:New(WF_QuestTools.AddonID, 2, "UISettings", WF_QuestTools.UISettings, "QT")
		end,
	}
)
